Create a token budget - Barndoor Documentation

Create a token budget

cURL

curl --request POST \
  --url https://app.barndoor.ai/api/llm-gateway/admin/budgets \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "<string>",
  "token_limit": 1,
  "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "scope_value": "<string>",
  "alert_thresholds": [
    80,
    90
  ],
  "traffic_type": "all",
  "cost_limit": 123,
  "currency": "USD",
  "target_provider_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "target_upstream_model": "<string>",
  "target_model_alias": "<string>"
}
'

Python

import requests

url = "https://app.barndoor.ai/api/llm-gateway/admin/budgets"

payload = {
    "name": "<string>",
    "token_limit": 1,
    "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "scope_value": "<string>",
    "alert_thresholds": [80, 90],
    "traffic_type": "all",
    "cost_limit": 123,
    "currency": "USD",
    "target_provider_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "target_upstream_model": "<string>",
    "target_model_alias": "<string>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch API)

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: '<string>',
    token_limit: 1,
    scope_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    scope_value: '<string>',
    alert_thresholds: [80, 90],
    traffic_type: 'all',
    cost_limit: 123,
    currency: 'USD',
    target_provider_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    target_upstream_model: '<string>',
    target_model_alias: '<string>'
  })
};

fetch('https://app.barndoor.ai/api/llm-gateway/admin/budgets', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://app.barndoor.ai/api/llm-gateway/admin/budgets",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => '<string>',
    'token_limit' => 1,
    'scope_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    'scope_value' => '<string>',
    'alert_thresholds' => [
        80,
        90
    ],
    'traffic_type' => 'all',
    'cost_limit' => 123,
    'currency' => 'USD',
    'target_provider_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
    'target_upstream_model' => '<string>',
    'target_model_alias' => '<string>'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://app.barndoor.ai/api/llm-gateway/admin/budgets"

payload := strings.NewReader("{\n  \"name\": \"<string>\",\n  \"token_limit\": 1,\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"alert_thresholds\": [\n    80,\n    90\n  ],\n  \"traffic_type\": \"all\",\n  \"cost_limit\": 123,\n  \"currency\": \"USD\",\n  \"target_provider_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"target_upstream_model\": \"<string>\",\n  \"target_model_alias\": \"<string>\"}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Swift

HttpResponse<String> response = Unirest.post("https://app.barndoor.ai/api/llm-gateway/admin/budgets")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"<string>\",\n  \"token_limit\": 1,\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"alert_thresholds\": [\n    80,\n    90\n  ],\n  \"traffic_type\": \"all\",\n  \"cost_limit\": 123,\n  \"currency\": \"USD\",\n  \"target_provider_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"target_upstream_model\": \"<string>\",\n  \"target_model_alias\": \"<string>\"}")
  .asString();

Ruby

require 'uri'
require 'net/http'

url = URI("https://app.barndoor.ai/api/llm-gateway/admin/budgets")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"<string>\",\n  \"token_limit\": 1,\n  \"scope_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"scope_value\": \"<string>\",\n  \"alert_thresholds\": [\n    80,\n    90\n  ],\n  \"traffic_type\": \"all\",\n  \"cost_limit\": 123,\n  \"currency\": \"USD\",\n  \"target_provider_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n  \"target_upstream_model\": \"<string>\",\n  \"target_model_alias\": \"<string>\"}"

response = http.request(request)
puts response.read_body

Responses

Success Response

{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "org_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "name": "Engineering monthly tokens",
  "token_limit": 50000000,
  "alert_thresholds": [
    80,
    90
  ],
  "traffic_type": "all",
  "currency": "USD",
  "enabled": true,
  "scope_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "scope_value": "<string>",
  "cost_limit": 123,
  "target_provider_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "target_upstream_model": "<string>",
  "target_model_alias": "<string>"
}

Error Response

{
  "error": "BadRequest",
  "message": "request_timeout_secs must be between 1 and 3600"
}